# Contributing

We rely on the community to help maintain this project so please submit issues and PRs to help make this a better package. 

### When submitting issues...
 - Please provide as much information as possible for us to replicate the issue.
 - Provide contextual information such OS, RN version, package version, etc.
 - Understand that while we will do our best to answer your issue, this is free support and we might not be able to resovle it immediately.
 
### When submitting PRs...
 - Provide as much details as possible with regard to the issue (include links if applicable) its resolving, the use cases, purpose, etc.
 - Update documentation files where applicable.
 - Help clean up... if you notice formating / style issues, feel free to help correct.
 - As with issues, we will do our best to review PRs in a timely manner but feel free to bump it if we haven't made it to it yet.
 - Keep in mind this is a wrapper for the underlying SDKs, and as such, we're not in the business of creating a whole new "SDK" on top of them. As much as possible, stick to the underlying methods. Helper methods are convenient, but they're not part of the core SDKs we're implementing.
 
Thanks in advance for your help!
